<script lang="ts">
import { computed, h, PropType, useAttrs } from 'vue';
import iconsListConfig from './icons-list-config';

export default {
  name: 'JIcon',
};
</script>

<script lang="ts" setup>
const props = defineProps({
  icon: {
    type: String as PropType<keyof typeof iconsListConfig>,
    required: true,
  },
  containerSize: {
    type: Boolean,
    default: false,
  },
  hideIconWrapper: {
    type: Boolean,
    default: false,
  },
  size: {
    type: String,
    default: '16px',
  },
  borderRadius: {
    type: String,
    default: '4px',
  },
  slotWrapper: {
    type: Boolean,
    default: false,
  },
});

const attrs = useAttrs();

let iconAttrs = {};

if (attrs.viewBox) {
  iconAttrs = {
    viewBox: attrs.viewBox,
  };
}

const SvgNode = computed(() => {
  const hoverIcon = 'hover' in iconsListConfig[props.icon] ? iconsListConfig[props.icon].hover : null;

  const SvgUseNode = h('use', { href: `#${props.icon}`, default: '' });

  const SvgUseHoverNode = hoverIcon
    ? h('use', { href: `#${hoverIcon}`, hover: '' })
    : null;

  const render = h(
    'svg',
    {
      ...iconAttrs,
      class: ['j-icon', { 'j-container-size': props.containerSize }, iconsListConfig[props.icon].class],
      style: iconsListConfig[props.icon]?.styles ?? '', 
      'aria-hidden': true,
      'with-hover': hoverIcon ? '' : null,
    },
    [SvgUseNode, SvgUseHoverNode]
  );

  return render;
});
</script>

<template>
  <div v-if="slotWrapper && hideIconWrapper === false" class="j-icon-slot">
    <div class="j-icon-wrapper">
      <SvgNode />
    </div>

    <slot />
  </div>

  <div v-else-if="hideIconWrapper === false" class="j-icon-wrapper">
    <SvgNode />
  </div>

  <div v-else class="j-icon-base">
    <SvgNode base />
  </div>
</template>

<style lang="scss" scoped>
.j-container-size {
  width: 100%;
  height: 100%;
}

.j-icon-wrapper {
  display: inline-flex;
  justify-content: center;
  align-items: center;
  width: v-bind(size);
  height: v-bind(size);
  border-radius: v-bind(borderRadius);
  overflow: hidden;
}

.j-icon-wrapper,
.j-icon-slot {
  display: flex;
  max-height: 100%;

  &:hover {
    :deep {
      .j-icon[with-hover] {
        use[default] {
          display: none;
        }

        use[hover] {
          display: initial;
        }
      }
    }
  }
}

.j-icon-base {
  display: flex;
  align-items: center;
  max-height: 100%;

  :deep(.j-icon) {
    &[with-hover]:hover {
      use[default] {
        display: none;
      }

      use[hover] {
        display: initial;
      }
    }
  }
}

:deep(.j-icon) {
  overflow: hidden;
  width: 100%;
  height: 100%;

  use[hover] {
    display: none;
  }

  // TODO: понять зачем svg этот класс и что его встраивает
  &.st0 use {
    fill: none;
    stroke: #000;
    stroke-width: 2;
    stroke-linecap: round;
    stroke-linejoin: round;
    stroke-miterlimit: 10;
  }
}
</style>
